/*
Driver pour le tlmtre US I2C




*/

BOOLEAN ext_eeprom_ready(int addresschip) {
   int1 ack;
   i2c_start();            // If the write command is acknowledged,
   ack = i2c_write(addresschip);  // then the device is ready.
   i2c_stop();
   return !ack;
}


void write_SRF02_US(int addresschip, int address, BYTE data) {
//ecriture vers le telemetre US I2C
   while(!ext_eeprom_ready(addresschip));
   i2c_start();
   i2c_write(addresschip);//boitier  crire
   i2c_write(address);//registre  crire
   i2c_write(data);//donne  crire
   i2c_stop();
}

BYTE read_SRF02_US(int addresschip, int address) {
//lecture en provenance d'un telemetre US I2C
   BYTE data;

   while(!ext_eeprom_ready(addresschip));
   i2c_start();
   i2c_write(addresschip);//boitier  lire
   i2c_write(address);//registre  lire
   i2c_start();
   i2c_write(addresschip+1);//mode lecture
   data=i2c_read(0);//lecture
   i2c_stop();
   return(data);
}


void TelemetreUS_changeadresse(int OldAdress, int NewAdress){
/*Modifie l'adresse du telemetre
pour cela on ecrit dans l'ordre : 0xA0, 0xAA, 0xA5 ,NewAdresse
ATTENTION : ne mettre qu'un module telemetre en mme temps sur le bus I2C lors d'une changement d'adresse !

exemple : TelemetreUS_changeadresse(0xE0,0xE8) permet de passer de l'adresse 0xE8  0xE6

OK TESTEE
*/
   write_SRF02_US(OldAdress, 0x00,0xA0);
   write_SRF02_US(OldAdress, 0x00,0xAA);
   write_SRF02_US(OldAdress, 0x00,0xA5);
   write_SRF02_US(OldAdress, 0x00,NewAdress);


}//fin TelemetreUS_changeadresse

long int TelemetreUS_mesure (int AdresseBoitier)
{
/*
Configurer l'unit de mesure : 
   ecrire lavaleur
    l'adresse du registre de commande 
   dans le boitier i2c

Attendre au moins 66us
Lire le resultat (poids fort mesure adresse 02, poids faible mesure adresse 03)

exemple : mesure = TelemetreUS_mesure(0xE0) avec int16 mesure et adresse du boitier 0xE0

OK TESTEE
*/
   int16 data=0;

   write_SRF02_US(AdresseBoitier,0x00,0x51);//lancement de la mesure en cm        
   delay_ms(70);//attente fin mesure
   //lecture du resultat adresse 02 et 03 
   data = read_SRF02_US(AdresseBoitier, 0x02)<<8;//lecture de la mesure
   data |= read_SRF02_US(AdresseBoitier, 0x03);
   delay_ms(70);//attente fin mesure
   
   return(data);

}//fin TelemetreUS_mesure





