/*
Permet de tester un module tlmtre US I2C sur la carte picv2
Le programme change l'adresse de 0xE0  0xE6
puis lance en boucle une mesure qui s'affiche sur l'cran LCD.

A utiliser pour changer l'adresse d'une module USI2C.

*/

#include <16F876A.h>
#device adc=8
#use delay(clock=20000000)
#fuses NOWDT,HS, NOPUT, NOPROTECT, NODEBUG, BROWNOUT, NOLVP, NOCPD, NOWRT
#define EEPROM_SCL   PIN_C3
#define EEPROM_SDA   PIN_C4
#use rs232(baud=9600,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=8)
#use i2c(Master,Slow,sda=PIN_C4,scl=PIN_C3)

#include <PCF2119_driver_LCDI2C.c>
#include <string.h>
#include <max517_driver.c>
#include <driver_telemetreUS_I2C.c>


void init(){
   setup_adc_ports(AN0_AN1_AN3);
   setup_adc(ADC_CLOCK_INTERNAL);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);

}//fin init


/*************************************/

void main()
{
int i;
int16 distance=0;
   init();
   Init_Ecran();                                         // initialisation de l'ecran (affiche des triangles)
   delay_ms(1000);                                       // tempo permettant de visualiser la mise en marche de l'ecran
   Efface_Ecran();                                       // Effacement de l'ecran avec position curseur en haut a gauche
   delay_ms(1000); 

   Lcd_Place_Curseur(1,1);                                  // Deplace le curseur a la position fixee par ligne et colonne 
   printf(Affiche_caractere,"Test telemetre \n"); 
   distance = 124;
   Lcd_Place_Curseur(2,1);
   printf(Affiche_caractere,"Distance= %lu" distance);
   //TelemetreUS_changeadresse(0xE0, 0xE6);
   Efface_Ecran();
   printf(Affiche_caractere,"Adresse change");   
while(1){
   Efface_Ecran();
   output_high(PIN_C0);
   distance = TelemetreUS_mesure(0xE6);  
   Lcd_Place_Curseur(2,1);
   printf(Affiche_caractere,"Distance= %lu" distance);
   delay_ms(500);output_low(PIN_C0);
}//while

}
